include "Vram.inc"
include "VVram.inc"
; include "Chars.inc"

ext VVramFront_
ext Chars_, Ascii_

VramTop equ Vram+VramWidth*6
CharHeight equ 6

dseg
Backup: defs VVramWidth*VVramHeight

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,VramWidth*64
        do
            ld (hl),0aah
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop hl | pop af
ret


; ; ptr<byte> VramPtr(byte x, byte y);
; cseg
; RowPtrs:
; defw Vram+32
; defw Vram+128
; defw Vram+192
; defw Vram+288
; defw Vram+352
; defw Vram+448
; defw Vram+512
; defw Vram+608
; defw Vram+672
; defw Vram+768
; defw Vram+832
; defw Vram+928
; defw Vram+992
; defw Vram+1088
; defw Vram+1152
; defw Vram+1248
; defw Vram+1312
; defw Vram+1408
; defw Vram+1472
; defw Vram+1568
; defw Vram+1632
; defw Vram+1728
; defw Vram+1792
; defw Vram+1888
; defw Vram+1952

; VramPtr_: public VramPtr_
;     push af | push hl | push de
;         ld d,0
;         ex de,hl
;             add hl,hl
;             ld de,RowPtrs
;             add hl,de
;             ld e,(hl) | inc hl
;             ld d,(hl)
;         ex de,hl
;         ld e,a
;         ld d,0
;         ld hl,Vram
;         add hl,de
;     pop de | pop hl | pop af
; ret


CharPtrDe:
    push hl
        ld l,a
        ld h,0
        ld e,l
        ld d,h
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,de ;*6
        ld de,Chars_
        add hl,de
        ex de,hl
    pop hl
ret


; ptr<byte> Put3(ptr<byte> pVram, byte c);
cseg
Put3_: public Put3_
    push af | push hl | push de | push bc
        ld a,e
        call CharPtrDe
        ld bc,VramWidth
        ld a,(de) | inc de
        ld (hl),a | add hl,bc
        ld a,(de) | inc de
        ld (hl),a | add hl,bc
        ld a,(de)
        ld (hl),a
    pop bc | pop de | pop hl | pop af
    inc hl
ret


; ptr<byte> Put2(ptr<byte> pVram, byte c);
cseg
Put2_: public Put2_
    push af | push hl | push de | push bc
        ld a,e
        call CharPtrDe
        ld bc,VramWidth
        inc de | inc de | inc de
        ld a,(de) | inc de
        ld (hl),a | add hl,bc
        ld a,(de)
        ld (hl),a
    pop bc | pop de | pop hl | pop af
    inc hl
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,VramTop
        exx
        ld c, VVramHeight/2
        do
            ld b,VVramWidth
            do 
                ld a,(de)
                inc de
                cp (hl)
                if nz
                    ld (hl),a
                    exx
                        call CharPtrDe
                        ld bc,VramWidth
                        ld a,(de) | inc de
                        ld (hl),a | add hl,bc
                        ld a,(de) | inc de
                        ld (hl),a | add hl,bc
                        ld a,(de)
                        ld (hl),a
                        ld bc,1-VramWidth*2
                        add hl,bc
                    exx
                else
                    exx
                        inc hl
                    exx
                endif
                inc hl
            dwnz
            exx
                ld bc,VramWidth*2
                add hl,bc
            exx

            ld b,VVramWidth
            do 
                ld a,(de)
                inc de
                cp (hl)
                if nz
                    ld (hl),a
                    exx
                        call CharPtrDe
                        ld bc,VramWidth
                        inc de | inc de | inc de
                        ld a,(de) | inc de
                        ld (hl),a | add hl,bc
                        ld a,(de)
                        ld (hl),a
                        ld bc,1-VramWidth*1
                        add hl,bc
                    exx
                else
                    exx
                        inc hl
                    exx
                endif
                inc hl
            dwnz
            exx
                ld bc,VramWidth*1
                add hl,bc
            exx

            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb " 0123456789ACEFGHIKMOPRSTUVY"
PrintC_: public PrintC_
    push af | push hl | push de | push bc
        push hl
            ld bc,28*256
            ld hl,CharTable
            ld a,e
            do
                cp (hl)
                jr z,PrintC_break
                inc hl
                inc c
            dwnz
            ld c,0
            PrintC_break:
            ld a,c
        pop hl
        ex de,hl
            ld l,a
            ld h,0
            add hl,hl ; *2
            ld c,l | ld b,h
            add hl,hl ; *4
            add hl,bc ; *6
            ld bc,Ascii_
            add hl,bc
        ex de,hl
        ld bc,VramWidth
        ld a,CharHeight
        do
            ex af,af'
                ld a,(de) | inc de
                ld (hl),a
            ex af,af'
            add hl,bc
            dec a
        while nz | wend
    pop bc | pop de | pop hl | pop af
    inc hl
ret
